// lab4ex.cpp : lab4 solution code
//

#include "stdafx.h"
#include <conio.h>
#include <iostream>
using namespace std;
const int STRSIZE = 64;

// each instance of this struct represents one character in the string
struct cnode {
       char c;  // data for this node
       cnode * next;  // pointer to the next node
}; // cnode

// add a data element to the front of the list. Returns true if OK
bool
add_to_front(cnode * & front,char data)
{
    cnode * new_node;

    if( (new_node = new cnode) == NULL) {
        cerr << " no memory for cnode \n";
        return false;
    }
    new_node->c = data; // save the data in the node
    new_node->next=front;   // point this one at the old front one
    front = new_node;  // front now points to this
    return true;
} // add_to_front

// add a data element to the back of the list. Returns true if OK
bool
add_to_end(cnode * & front,char data)
{
    cnode * new_node;
    cnode * ptr = front;

    if( (new_node = new cnode) == NULL) {
        cerr << " no memory for cnode \n";
        return false;
    }
    new_node->c = data;  // store data in this node
    new_node->next = NULL; // since added to end , this must be NULL

    //if the list is empty then the last is the first, so put it
    //on the front of the list
    if(front == NULL) {
            front = new_node;
            return true;
    }

    // if not, we have to find the last element in the list
    // The last element is the one whose next pointer is NULL
    while(ptr->next != NULL) ptr = ptr->next;
    // now ptr points to the last element in the list
    // so make it point to the new one
    ptr->next = new_node;
    return true;
} // add_to_end

// put the characters from the cstring into a list
void
strtolist(cnode *& front,char * source)
{
        char * ptr = source;
        while(*ptr) {
//                cout << "adding char " << (char) *ptr << endl;
                if(!add_to_end(front,*ptr)) {
                        cerr << "adding char " << (char) *ptr << "failed" << endl;
                        return;
                }
                ptr++;
        } // while
} // strtolist

// print the characters in the string list and a new line at the end
void
print_list(cnode * front)
{
        cnode *ptr = front;  // always copy the pointer
        if(front == NULL) return;   // nothing to print
        while(ptr != NULL) {
                cout << ptr->c;
                ptr = ptr->next;
        } // while
        cout << endl;
} // print_list

// traverse the string list and change each character to uppercase.
void
uppercase(cnode * str)
{
	const int CAPDIFF = 'a' - 'A';   // diff between upper and lower case letters
	while(str != NULL) {
			if((str->c >= 'a') && (str->c <= 'z') ) { // it's between lowercase a and z
					str->c -= CAPDIFF; // change the lowercase letter to uppercase
			}
			str = str->next;
	} // while
} // uppercase

// traverse the string list and change each occurence of target into newchar
void
changeit(cnode * str, char target, char newchar)
{
	while(str != NULL) {
			if(str->c == target) {
					str->c = newchar;
			}
			str = str->next;
	} // while
} // changeit

// attach the second string to the end of the first and return a pointer to 
// the resulting string
// A common alternative is to read each char from list2 and use add_to_end()
// to copy it to the end of the first.
cnode *
concat(cnode * first, cnode * second)
{
	cnode * ptr = first;
	if(first == NULL) return second;  // no first string so return second one
	if(second == NULL) return first;  // no second string so return first one
	while(ptr->next != NULL) ptr = ptr->next;  // find last node in first string
	ptr->next = second;  // point it to second string
	return first;
} // concat

int main(int argc, char* argv[])
{
		char * data1 = "LowerCasE";  // test data for uppercase function
		char * data2 = "letter";     // test data for changeit function
		char * data3 = "Doctor ";    // test data for concat function
		char * data4 = "Who ";       // test data for concat function
		cnode * lcstring = NULL;     // list pointer for uppercase test
		cnode * chngstring = NULL;   // list pointer for changeit test
		cnode * catstring1 = NULL;   // list pointer for concat test
		cnode * catstring2 = NULL;   // list pointer for concat test
		cnode * catresstring = NULL; // list pointer for concat test result

		strtolist(lcstring,data1);     // set up uppercase test string
		strtolist(chngstring,data2);   // set up changeit test string
		strtolist(catstring1,data3);   // set up concat test string
		strtolist(catstring2,data4);   // set up concat test string

		cout << "Now testing uppercase, the initial string is:" << endl;
		print_list(lcstring);
		cout << "after changing to uppercase the string is:" << endl;
		uppercase(lcstring);
		print_list(lcstring);
		cout << endl << endl;

		cout << "Now testing changeit, the target is 't', the new letter is 's',the initial string is:" << endl;
		print_list(chngstring);
		cout << "after changing the target letters the string is:" << endl;
		changeit(chngstring,'t','s');
		print_list(chngstring);
		cout << endl << endl;
		
		cout << "Now testing concat, the first string is:" << endl;
		print_list(catstring1);
		cout << "the second string is:" << endl;
		print_list(catstring2);

		cout << "after changing the target letters the string is:" << endl;
		catresstring = concat(catstring1,catstring2);
		print_list(catresstring);
		cout << endl << endl;

	char c;
	cout << "Hit enter to end the program";
	c = _getch();
	return 0;
}
